<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2015, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
class SMWIDGETS_CMP_Facebook extends BASE_CLASS_Widget
{
    public function __construct(BASE_CLASS_WidgetParameter $params) {
        parent::__construct();
		
		$userId = $params->additionalParamList['entityId'];
		
		$username = SMWIDGETS_BOL_Service::getInstance()->getFieldValue('smwidgets_facebook_id', $userId);
		$config = OW::getConfig();
		$lang = OW::getLanguage();
		
		if(!empty($username)){
		
			$width = $config->getValue('smwidgets', 'data_width');
			$height = $config->getValue('smwidgets', 'data_height');
			$faces = $config->getValue('smwidgets', 'fb_data_faces');
			$stream = $config->getValue('smwidgets', 'fb_data_stream');
			$border = $config->getValue('smwidgets', 'fb_show_border');
			$header = $config->getValue('smwidgets', 'fb_show_header');
			$color = $config->getValue('smwidgets', 'color_scheme');
			
			$script = "<div id='fb-root'></div>
				<script>(function(d, s, id) {
				  var js, fjs = d.getElementsByTagName(s)[0];
				  if (d.getElementById(id)) return;
				  js = d.createElement(s); js.id = id;
				  js.src = '//connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.0';
				  fjs.parentNode.insertBefore(js, fjs);
				}(document, 'script', 'facebook-jssdk'));</script>
			";
			
			OW::getDocument()->appendBody($script);
			
			$cmp = "
				<div class='fb-like-box' data-href='https://www.facebook.com/$username' data-width='$width' data-height='$height' data-colorscheme='$color' data-show-faces='$faces' data-header='$header' data-stream='$stream' data-show-border='$border'></div>
			";
			
			$this->assign('cmp', $cmp);
			
		}
		else{
			
			if(SMWIDGETS_BOL_Service::getInstance()->isOwner($userId) && SMWIDGETS_BOL_Service::getInstance()->showBtn()){
				
				$customParam = array(
					'elemId' => 'fb_btn',
					'inviteTxt' => $lang->text("smwidgets", "fb_btn_nag")
				);
				
				$cmp = new SMWIDGETS_CMP_Button($customParam);
				$this->addComponent('cmp', $cmp);
				
			}
			else{
			
				if (!$params->customizeMode){
					
					$this->setVisible(false);
					
				}
				$this->assign('cmp', null);
			}
		}
    }

    public static function getStandardSettingValueList() {
        return array(
            self::SETTING_TITLE => OW::getLanguage()->text('smwidgets', 'facebook_widget_title'),
            self::SETTING_ICON => self::ICON_USER,
            self::SETTING_SHOW_TITLE => true,
            self::SETTING_WRAP_IN_BOX => true
        );
    }

    public static function getAccess() {
        return self::ACCESS_ALL;
    }
}