<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2015, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
class SMWIDGETS_CMP_Twitter extends BASE_CLASS_Widget
{
	public function __construct(BASE_CLASS_WidgetParameter $params) {
		parent::__construct();
        
		$userId = $params->additionalParamList['entityId'];
		$lang = OW::getLanguage();
		$username = SMWIDGETS_BOL_Service::getInstance()->getFieldValue('smwidgets_twitter_id', $userId);
		$config = OW::getConfig();
		
		if(!empty($username)){
		
			$width = $config->getValue('smwidgets', 'data_width');
			$height = $config->getValue('smwidgets', 'data_height');
			$links = $config->getValue('smwidgets', 'tw_link');
			$theme = $config->getValue('smwidgets', 'color_scheme');
			$tweetHeading = $lang->text("smwidgets", "tweets_by");
			$followInvitation = $lang->text("smwidgets", "twitter_follow_btn");
		
			$cmp = "
			
				<a class='twitter-timeline ' href='https://twitter.com/$username' data-widget-id='560860358790107137' data-theme='$theme' data-link-color='$links' width='$width' height='$height' data-screen-name='$username'> 
					$tweetHeading @$username
				</a>
				
				<div class='ow_center'><a href='https://twitter.com/$username' class='twitter-follow-button' data-show-count='false'>$followInvitation @$username</a></div>
				
				<script>window.twttr = (function(d, s, id) {
				  var js, fjs = d.getElementsByTagName(s)[0],
					t = window.twttr || {};
				  if (d.getElementById(id)) return t;
				  js = d.createElement(s);
				  js.id = id;
				  js.src = 'https://platform.twitter.com/widgets.js';
				  fjs.parentNode.insertBefore(js, fjs);
				 
				  t._e = [];
				  t.ready = function(f) {
					t._e.push(f);
				  };
				 
				  return t;
				}(document, 'script', 'twitter-wjs'));</script>
				
			";
			
			$this->assign('cmp', $cmp);
			
		}
		else{
			
			if(SMWIDGETS_BOL_Service::getInstance()->isOwner($userId) && SMWIDGETS_BOL_Service::getInstance()->showBtn()){
				
				$customParam = array(
					'elemId' => 'tw_btn',
					'inviteTxt' => $lang->text("smwidgets", "tw_btn_nag")
				);
				
				$cmp = new SMWIDGETS_CMP_Button($customParam);
				$this->addComponent('cmp', $cmp);
			}
			else{
			
				if (!$params->customizeMode){
					
					$this->setVisible(false);
					
				}
				$this->assign('cmp', null);
			}
		}
    }

    public static function getStandardSettingValueList() {
        return array(
            self::SETTING_TITLE => OW::getLanguage()->text('smwidgets', 'twitter_widget_title'),
            self::SETTING_ICON => self::ICON_USER,
            self::SETTING_SHOW_TITLE => true,
            self::SETTING_WRAP_IN_BOX => true
        );
    }
    public static function getAccess() {
        return self::ACCESS_ALL;
    }	
}